// Individual.cpp: implementation of the CIndividual class.
//
//////////////////////////////////////////////////////////////////////

#include "Individual.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

int CIndividual::N_of_x             = 100;
int CIndividual::N_of_constr        = 100;
int CIndividual::index_of_constrain = 1;

CIndividual::CIndividual()
{
	xreal = new double[N_of_x];
	constr = new double[N_of_constr];
	int i;
	for (i=0;i<N_of_x;i++)
	{
		xreal[i] = -1.0;
	}
	for (i=0;i<N_of_constr;i++)
	{
		constr[i] = -1.0;
	}
	constr_violation = -1.0;
	obj              = -1.0;
	fitness          = -1.0;
	feasible         = 0;
	no_of_violation  = 0;
}

CIndividual::~CIndividual()
{
	delete []xreal;
	if((N_of_constr != 0)) delete[] constr;
}

CIndividual::CIndividual(const CIndividual &t)
{
	// жǷͬ
	if(&t == this)
	{
		return;
	}

	// ֵthis
	xreal = new double[N_of_x];
	constr = new double[N_of_constr];
	int i;
	for (i=0;i<N_of_x;i++)
	{
		xreal[i] = t.xreal[i];
	}
	obj = t.obj;
	fitness = t.fitness;
	for (i=0;i<N_of_constr;i++)
	{
		constr[i] = t.constr[i];
	}
	constr_violation = t.constr_violation;
	feasible         = t.feasible;
	no_of_violation  = t.no_of_violation;
}

CIndividual &CIndividual::operator =(const CIndividual &t)
{
	// жǷͬ
	if(&t == this)
	{
		return *this;
	}

    // !!!!жǷѾռ,Ҫ,Ȼڴ治ͷ!!!!
	if ((N_of_x != 0) && (xreal)) delete[] xreal;
	if((N_of_constr != 0) && (constr)) delete[] constr;

	xreal = new double[N_of_x];
	constr = new double[N_of_constr];
	int i;
	for (i=0;i<N_of_x;i++)
	{
		xreal[i] = t.xreal[i];
	}
	obj = t.obj;
	fitness = t.fitness;
	for (i=0;i<N_of_constr;i++)
	{
		constr[i] = t.constr[i];
	}
	constr_violation = t.constr_violation;
	feasible         = t.feasible;
	no_of_violation  = t.no_of_violation;

	return *this;
}
